Subject: Re: [PATCH] natsemi: add checks for dma mapping errors

From: Alexey Khoroshilov <[email-masked]>
Date: Sat, 19 Dec 2015 15:06:45 +0300

On 19.12.2015 05:36, David Miller wrote:
> From: Alexey Khoroshilov <[email-masked]>
> Date: Sat, 19 Dec 2015 00:55:37 +0300
>
>> @@ -2093,6 +2099,10 @@ static netdev_tx_t start_tx(struct sk_buff
*skb, struct net_device *dev)
>>  	np->tx_skbuff[entry] = skb;
>>  	np->tx_dma[entry] = pci_map_single(np->pci_dev,
>>  				skb->data,skb->len, PCI_DMA_TODEVICE);
>> +	if (pci_dma_mapping_error(np->pci_dev, np->tx_dma[entry])) {
>> +		np->tx_skbuff[entry] = NULL;
>> +		return NETDEV_TX_BUSY;
>> +	}
>>
>>  	np->tx_ring[entry].addr = cpu_to_le32(np->tx_dma[entry]);
>>
>
> Returning NETDEV_TX_BUSY and freeing the SKB will crash the system.

I do not quite understand what do you mean by 'freeing the SKB'.
At least the patch left skb untouched.

But I saw such pattern, for example, in
drivers/net/ethernet/freescale/fec_main.c:

	addr = dma_map_single(&fep->pdev->dev, data, size, DMA_TO_DEVICE);
	if (dma_mapping_error(&fep->pdev->dev, addr)) {
		dev_kfree_skb_any(skb);
		if (net_ratelimit())
			netdev_err(ndev, "Tx DMA memory map failed\n");
		return NETDEV_TX_BUSY;
	}

>
> NETDEV_TX_BUSY is only for buggy drivers that do not manage their
> TX ring busy condition correctly, and thus need retries.

Ok, I will replace NETDEV_TX_BUSY by dropping the packet.

--
Alexey